import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import { withKnobs, select } from '@storybook/addon-knobs';
import readme from './readme.md';
import { FormTextareaVariation } from './form-textarea-variation.enum';
import { FormTextareaValidation } from './form-textarea-validation.enum';

<Meta
  title="Form/digi-form-textarea"
  parameters={{
    actions: {
      handles: [
        'afOnChange',
        'afOnBlur',
        'afOnKeyup',
        'afOnFocus',
        'afOnFocusout',
        'afOnInput',
        'afOnDirty',
        'afOnTouched'
      ]
    }
  }}
  decorators={[withKnobs]}
/>

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Standard

This is the standard textarea. The label is required!

<Canvas>
  <Story name="Standard">
    /* html */
    {`
      <digi-form-textarea
        af-label="I am a label"
        af-label-description="This is an extraordinarily basic textarea"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

## Variations

The component exists in a few different variations. Typescript users should import and use `FormTextareaVariation` to set variation.

### SMALL

Variation SMALL makes the textarea small.

<Canvas>
  <Story name="Variation - SMALL">
    /* html */
    {`
      <digi-form-textarea
        af-variation="${FormTextareaVariation.SMALL}"
        af-label="I am a label"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

### MEDIUM

Variation MEDIUM makes the textarea medium. This is the default behavior and should look just like the standard version

<Canvas>
  <Story name="Variation - MEDIUM">
    /* html */
    {`
      <digi-form-textarea
        af-variation="${FormTextareaVariation.MEDIUM}"
        af-label="I am a label"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

### LARGE

Variation LARGE makes the textarea large.

<Canvas>
  <Story name="Variation - LARGE">
    /* html */
    {`
      <digi-form-textarea
        af-variation="${FormTextareaVariation.LARGE}"
        af-label="I am a label"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

### AUTO

Variation AUTO makes the textarea auto sized.

<Canvas>
  <Story name="Variation - AUTO">
    /* html */
    {`
      <digi-form-textarea
        af-variation="${FormTextareaVariation.AUTO}"
        af-label="I am a label"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>


## Validiation

The component exists in a few different validation states. It can be valid or invalid. Typescript users should import and use `FormTextareaValidation` to set validation.

### Success

Success renders a valid version of the textarea.

<Canvas>
  <Story name="Validation - Success">
    /* html */
    {`
      <digi-form-textarea
        af-validation="${FormTextareaValidation.SUCCESS}"
        af-validation-text="I am a success validation message"
        af-label="I am a success textarea"
        af-value="I am a value"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

### Error

Error renders an invalid version of the textarea.

<Canvas>
  <Story name="Validation - Error">
    /* html */
    {`
      <digi-form-textarea
        af-validation="${FormTextareaValidation.ERROR}"
        af-validation-text="I am an error validation message"
        af-label="I am an error textarea"
        af-value="I am a value"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>

### Warning

Warning renders a warning version of the textarea.

<Canvas>
  <Story name="Validation - Warning">
    /* html */
    {`
      <digi-form-textarea
        af-validation="${FormTextareaValidation.WARNING}"
        af-validation-text="I am a warning validation message"
        af-label="I am a warning textarea"
        af-value="I am a value"
      ></digi-form-textarea>
    `}
  </Story>
</Canvas>
